# ReleaseLicense

### Description

Releases a license key on the License Server.

```csharp
void ReleaseLicense (string webServiceUrl, 
                     string activationKey, 
                     string computerID, 
                     out string response)
```

### Parameters

| Parameter     |    Type    | Description                                                                            |
| ------------- | :--------: | -------------------------------------------------------------------------------------- |
| webServiceUrl |   string   | URL to the QLM License Server                                                          |
| activationKey |   string   | the license key to deactivate                                                          |
| computerID    |   string   | the unique computer identifier to deactivate                                           |
| response      | out string | XML fragment containing the result of the call. The Xml fragment schema is as follows: |

### Response XML format

```xml
<?xml version='1.0' encoding='UTF-8'?>
<QuickLicenseManager>
<result>ActivationKey A162DCF05C30D371A2D0E0461040A0 has been released.</result>
</QuickLicenseManager>
 
```

### Example error response

```xml
<?xml version='1.0' encoding='UTF-8'?>
<QuickLicenseManager>
<error>Details about the error</error>
</QuickLicenseManager>
```

## Remarks

You can control how many times a user can release a license with the following Server Properties:

* maxReleaseCount: The maximum number of times an end-user can release a license.
* maxReleasePeriodInDays: When counting the number of released licenses, only count the ones that have been released in the past "maxReleasePeriodInDays" days. For example, if you want to allow a user to release a license twice per month, set maxReleasePeriodInDays to 30 and maxReleaseCount to 2.
* maxReleasePerClient: When counting the number of released licenses for a given activation key, count only the ones associated with a specific client. By default, QLM counts all the released licenses for a given activation regardless of the client system.

By default, you must set the CommunicationEncryptionKey before calling ReleaseLicense. The server property releaseLicenseUseAdminEncryptionKey can be used to configure the server to require the AdminEncryption to be set in order to call ReleaseLicense.

Use [ParseResults ](/docs/api-reference/.net-api/iqlmcustomerinfo/methods/parseresults.md)to interpret the results of the call and load the returned data into an [ILicenseInfo ](/docs/api-reference/.net-api/ilicenseinfo.md)object.

```csharp
ILicenseInfo li = new LicenseInfo();
string message = string.Empty;
if (lv.QlmLicenseObject.ParseResults(response, ref li, ref message))
{
  // The operation  was successful	
}
else
{
  // The operation failed
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.soraco.co/docs/api-reference/.net-api/qlmlicense/application-methods/releaselicense.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
